## tdb 1.4.5

=== wscript ===
#!/usr/bin/env python

APPNAME = 'tdb'
VERSION = '1.4.5'

import sys, os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist, samba_utils
from waflib import Options, Logs, Context
import shutil

samba_dist.DIST_DIRS('lib/tdb:. lib/replace:lib/replace buildtools:buildtools third_party/waf:third_party/waf')

tdb1_unit_tests = [
    'run-3G-file',
    'run-bad-tdb-header',
    'run',
    'run-check',
    'run-corrupt',
    'run-die-during-transaction',
    'run-endian',
    'run-incompatible',
    'run-nested-transactions',
    'run-nested-traverse',
    'run-no-lock-during-traverse',
    'run-oldhash',
    'run-open-during-transaction',
    'run-readonly-check',
    'run-rescue',
    'run-rescue-find_entry',
    'run-rdlock-upgrade',
    'run-rwlock-check',
    'run-summary',
    'run-transaction-expand',
    'run-traverse-in-transaction',
    'run-wronghash-fail',
    'run-zero-append',
    'run-fcntl-deadlock',
    'run-marklock-deadlock',
    'run-allrecord-traverse-deadlock',
    'run-mutex-openflags2',
    'run-mutex-trylock',
    'run-mutex-allrecord-bench',
    'run-mutex-allrecord-trylock',
    'run-mutex-allrecord-block',
    'run-mutex-transaction1',
    'run-mutex-die',
    'run-mutex1',
    'run-circular-chain',
    'run-circular-freelist',
    'run-traverse-chain',
]

def options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.PRIVATE_EXTENSION_DEFAULT('tdb', noextension='tdb')
    opt.RECURSE('lib/replace')
    opt.add_option('--disable-tdb-mutex-locking',
                   help=("Disable the use of pthread robust mutexes"),
                   action="store_true", dest='disable_tdb_mutex_locking',
                   default=False)


def configure(conf):
    conf.env.disable_tdb_mutex_locking = getattr(Options.options,
                                                 'disable_tdb_mutex_locking',
                                                 False)
    if not conf.env.disable_tdb_mutex_locking:
        conf.env.replace_add_global_pthread = True
    conf.RECURSE('lib/replace')

    conf.env.standalone_tdb = conf.IN_LAUNCH_DIR()
    conf.env.building_tdb = True

    if not conf.env.standalone_tdb:
        if conf.CHECK_BUNDLED_SYSTEM_PKG('tdb', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TDB', 1)
            conf.env.building_tdb = False
            if not conf.env.disable_python and \
                conf.CHECK_BUNDLED_SYSTEM_PYTHON('pytdb', 'tdb', minversion=VERSION):
                conf.define('USING_SYSTEM_PYTDB', 1)

    if (conf.CONFIG_SET('HAVE_ROBUST_MUTEXES') and
        conf.env.building_tdb and
        not conf.env.disable_tdb_mutex_locking):
        conf.define('USE_TDB_MUTEX_LOCKING', 1)

    conf.CHECK_XSLTPROC_MANPAGES()

    conf.SAMBA_CHECK_PYTHON()
    conf.SAMBA_CHECK_PYTHON_HEADERS()

    conf.SAMBA_CONFIG_H()

    conf.SAMBA_CHECK_UNDEFINED_SYMBOL_FLAGS()

def build(bld):
    bld.RECURSE('lib/replace')

    COMMON_FILES='''check.c error.c tdb.c traverse.c
                    freelistcheck.c lock.c dump.c freelist.c
                    io.c open.c transaction.c hash.c summary.c rescue.c
                    mutex.c'''

    COMMON_SRC = bld.SUBDIR('common', COMMON_FILES)

    if bld.env.standalone_tdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        private_library = False
    else:
        private_library = True

    if not bld.CONFIG_SET('USING_SYSTEM_TDB'):

        tdb_deps = 'replace'

        if bld.CONFIG_SET('USE_TDB_MUTEX_LOCKING'):
            tdb_deps += ' pthread'

        bld.SAMBA_LIBRARY('tdb',
                          COMMON_SRC,
                          deps=tdb_deps,
                          includes='include',
                          abi_directory='ABI',
                          abi_match='tdb_*',
                          hide_symbols=True,
                          vnum=VERSION,
                          public_headers=('' if private_library else 'include/tdb.h'),
                          public_headers_install=not private_library,
                          pc_files='tdb.pc',
                          private_library=private_library)

        bld.SAMBA_BINARY('tdbtorture',
                         'tools/tdbtorture.c',
                         'tdb',
                         install=False)

        bld.SAMBA_BINARY('tdbrestore',
                         'tools/tdbrestore.c',
                         'tdb', manpages='man/tdbrestore.8')

        bld.SAMBA_BINARY('tdbdump',
                         'tools/tdbdump.c',
                         'tdb', manpages='man/tdbdump.8')

        bld.SAMBA_BINARY('tdbbackup',
                         'tools/tdbbackup.c',
                         'tdb',
                         manpages='man/tdbbackup.8')

        bld.SAMBA_BINARY('tdbtool',
                         'tools/tdbtool.c',
                         'tdb', manpages='man/tdbtool.8')

        if bld.env.standalone_tdb:
            # FIXME: This hardcoded list is stupid, stupid, stupid.
            bld.SAMBA_SUBSYSTEM('tdb-test-helpers',
                                'test/external-agent.c test/lock-tracking.c test/logging.c',
                                tdb_deps,
                                includes='include')

            for t in tdb1_unit_tests:
                b = "tdb1-" + t
                s = "test/" + t + ".c"
                bld.SAMBA_BINARY(b, s, 'replace tdb-test-helpers',
                                 includes='include', install=False)

    if not bld.CONFIG_SET('USING_SYSTEM_PYTDB'):
        bld.SAMBA_PYTHON('pytdb',
                         'pytdb.c',
                         deps='tdb',
                         enabled=not bld.env.disable_python,
                         realname='tdb.so',
                         cflags='-DPACKAGE_VERSION=\"%s\"' % VERSION)

        if not bld.env.disable_python:
            bld.SAMBA_SCRIPT('_tdb_text.py',
                             pattern='_tdb_text.py',
                             installdir='python')
            
            bld.INSTALL_FILES('${PYTHONARCHDIR}', '_tdb_text.py')

def testonly(ctx):
    '''run tdb testsuite'''
    ecode = 0

    blddir = Context.g_module.out
    test_prefix = "%s/st" % (blddir)
    shutil.rmtree(test_prefix, ignore_errors=True)
    os.makedirs(test_prefix)
    os.environ['TEST_DATA_PREFIX'] = test_prefix

    env = samba_utils.LOAD_ENVIRONMENT()
    # FIXME: This is horrible :(
    if env.building_tdb:
        # Create scratch directory for tests.
        testdir = os.path.join(test_prefix, 'tdb-tests')
        samba_utils.mkdir_p(testdir)
        # Symlink back to source dir so it can find tests in test/
        link = os.path.join(testdir, 'test')
        if not os.path.exists(link):
            os.symlink(ctx.path.make_node('test').abspath(), link)

        sh_tests = ["test/test_tdbbackup.sh test/jenkins-be-hash.tdb"]

        for sh_test in sh_tests:
            cmd = "BINDIR=%s %s" % (blddir, sh_test)
            print("shell test: " + cmd)
            ret = samba_utils.RUN_COMMAND(cmd)
            if ret != 0:
                print("%s sh test failed" % cmd)
                ecode = ret
                break

        for t in tdb1_unit_tests:
            f = "tdb1-" + t
            cmd = "cd " + testdir + " && " + os.path.abspath(os.path.join(blddir, f)) + " > test-output 2>&1"
            print("..." + f)
            ret = samba_utils.RUN_COMMAND(cmd)
            if ret != 0:
                print("%s failed:" % f)
                samba_utils.RUN_COMMAND("cat " + os.path.join(testdir, 'test-output'))
                ecode = ret
                break

    if ecode == 0:
        cmd = os.path.join(blddir, 'tdbtorture')
        ret = samba_utils.RUN_COMMAND(cmd)
        print("testsuite returned %d" % ret)
        if ret != 0:
            ecode = ret

    pyret = samba_utils.RUN_PYTHON_TESTS(['python/tests/simple.py'])
    print("python testsuite returned %d" % pyret)
    sys.exit(ecode or pyret)

# WAF doesn't build the unit tests for this, maybe because they don't link with tdb?
# This forces it
def test(ctx):
    Options.commands.append('build')
    Options.commands.append('testonly')

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    samba_utils.reconfigure(ctx)

=== buildtools/wafsamba/wscript ===
#!/usr/bin/env python

# this is a base set of waf rules that everything else pulls in first

import os, sys
from waflib import Configure, Logs, Options, Utils, Context, Errors
import wafsamba
from samba_utils import symlink
from optparse import SUPPRESS_HELP

# this forces configure to be re-run if any of the configure
# sections of the build scripts change. We have to check
# for this in sys.argv as options have not yet been parsed when
# we need to set this. This is off by default until some issues
# are resolved related to WAFCACHE. It will need a lot of testing
# before it is enabled by default.
if '--enable-auto-reconfigure' in sys.argv:
    Configure.autoconfig = 'clobber'

def default_value(option, default=''):
    if option in Options.options.__dict__:
        return Options.options.__dict__[option]
    return default

def options(opt):
    opt.load('compiler_cc')

    opt.load('gnu_dirs')

    gr = opt.option_group('library handling options')

    gr.add_option('--bundled-libraries',
                   help=("comma separated list of bundled libraries. May include !LIBNAME to disable bundling a library. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='BUNDLED_LIBS', default='')

    gr.add_option('--private-libraries',
                   help=("comma separated list of normally public libraries to build instead as private libraries. May include !LIBNAME to disable making a library private. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='PRIVATE_LIBS', default='')

    extension_default = default_value('PRIVATE_EXTENSION_DEFAULT')
    gr.add_option('--private-library-extension',
                   help=("name extension for private libraries [%s]" % extension_default),
                   action="store", dest='PRIVATE_EXTENSION', default=extension_default)

    extension_exception = default_value('PRIVATE_EXTENSION_EXCEPTION')
    gr.add_option('--private-extension-exception',
                   help=("comma separated list of libraries to not apply extension to [%s]" % extension_exception),
                   action="store", dest='PRIVATE_EXTENSION_EXCEPTION', default=extension_exception)

    builtin_default = default_value('BUILTIN_LIBRARIES_DEFAULT')
    gr.add_option('--builtin-libraries',
                   help=("command separated list of libraries to build directly into binaries [%s]" % builtin_default),
                   action="store", dest='BUILTIN_LIBRARIES', default=builtin_default)

    gr.add_option('--minimum-library-version',
                   help=("list of minimum system library versions (LIBNAME1:version,LIBNAME2:version)"),
                   action="store", dest='MINIMUM_LIBRARY_VERSION', default='')

    gr.add_option('--disable-rpath',
                   help=("Disable use of rpath for build binaries"),
                   action="store_true", dest='disable_rpath_build', default=False)
    gr.add_option('--disable-rpath-install',
                   help=("Disable use of rpath for library path in installed files"),
                   action="store_true", dest='disable_rpath_install', default=False)
    gr.add_option('--disable-rpath-private-install',
                   help=("Disable use of rpath for private library path in installed files"),
                   action="store_true", dest='disable_rpath_private_install', default=False)
    gr.add_option('--nonshared-binary',
                   help=("Disable use of shared libs for the listed binaries"),
                   action="store", dest='NONSHARED_BINARIES', default='')
    gr.add_option('--disable-symbol-versions',
                   help=("Disable use of the --version-script linker option"),
                   action="store_true", dest='disable_symbol_versions', default=False)

    opt.add_option('--with-modulesdir',
                   help=("modules directory [PREFIX/modules]"),
                   action="store", dest='MODULESDIR', default='${PREFIX}/modules')

    opt.add_option('--with-privatelibdir',
                   help=("private library directory [PREFIX/lib/%s]" % Context.g_module.APPNAME),
                   action="store", dest='PRIVATELIBDIR', default=None)

    opt.add_option('--with-libiconv',
                   help='additional directory to search for libiconv',
                   action='store', dest='iconv_open', default='/usr/local',
                   match = ['Checking for library iconv', 'Checking for iconv_open', 'Checking for header iconv.h'])
    opt.add_option('--without-gettext',
                   help=("Disable use of gettext"),
                   action="store_true", dest='disable_gettext', default=False)

    gr = opt.option_group('developer options')

    gr.add_option('-C',
                   help='enable configure caching',
                   action='store_true', dest='enable_configure_cache')
    gr.add_option('--enable-auto-reconfigure',
                   help='enable automatic reconfigure on build',
                   action='store_true', dest='enable_auto_reconfigure')
    gr.add_option('--enable-debug',
                   help=("Turn on debugging symbols"),
                   action="store_true", dest='debug', default=False)
    gr.add_option('--enable-developer',
                   help=("Turn on developer warnings and debugging"),
                   action="store_true", dest='developer', default=False)
    gr.add_option('--pidl-developer',
                   help=("annotate PIDL-generated code for developers"),
                   action="store_true", dest='pidl_developer', default=False)
    gr.add_option('--disable-warnings-as-errors',
                   help=("Do not treat all warnings as errors (disable -Werror)"),
                   action="store_true", dest='disable_warnings_as_errors', default=False)
    opt.add_option('--enable-coverage',
                   help=("enable options necessary for code coverage "
                         "reporting on selftest (default=no)"),
                   action="store_true", dest='enable_coverage', default=False)
    gr.add_option('--fatal-errors',
                   help=("Stop compilation on first error (enable -Wfatal-errors)"),
                   action="store_true", dest='fatal_errors', default=False)
    gr.add_option('--enable-gccdeps',
                   help=("Enable use of gcc -MD dependency module"),
                   action="store_true", dest='enable_gccdeps', default=True)
    gr.add_option('--pedantic',
		   help=("Enable even more compiler warnings"),
		   action='store_true', dest='pedantic', default=False)
    gr.add_option('--git-local-changes',
		   help=("mark version with + if local git changes"),
		   action='store_true', dest='GIT_LOCAL_CHANGES', default=False)
    gr.add_option('--address-sanitizer',
                   help=("Enable address sanitizer compile and linker flags"),
                   action="store_true", dest='address_sanitizer', default=False)
    gr.add_option('--undefined-sanitizer',
        help=("Enable undefined behaviour sanitizer compile and linker flags"),
        action="store_true",
        dest='undefined_sanitizer',
        default=False)
    gr.add_option('--enable-clangdb',
                   help=("Enable use of clang_compilation_database"),
                   action="store_true", dest='enable_clangdb', default=False)
    gr.add_option('--enable-libfuzzer',
                  help=("Build fuzzing binaries (use ADDITIONAL_CFLAGS to specify compiler options for libFuzzer or use CC=honggfuzz/hfuzz-cc)"),
                  action="store_true", dest='enable_libfuzzer', default=False)
    gr.add_option('--enable-afl-fuzzer',
                  help=("Build fuzzing binaries AFL-style (typically use with CC=afl-gcc)"),
                  action="store_true", dest='enable_afl_fuzzer', default=False)

    # Fuzz targets may need additional LDFLAGS that we can't use on
    # internal binaries like asn1_compile

    gr.add_option('--fuzz-target-ldflags',
                  help=("Linker flags to be used when building fuzz targets"),
                  action="store", dest='FUZZ_TARGET_LDFLAGS', default='')

    gr.add_option('--abi-check',
		   help=("Check ABI signatures for libraries"),
		   action='store_true', dest='ABI_CHECK', default=False)
    gr.add_option('--abi-check-disable',
		   help=("Disable ABI checking (used with --enable-developer)"),
		   action='store_true', dest='ABI_CHECK_DISABLE', default=False)
    gr.add_option('--abi-update',
		   help=("Update ABI signature files for libraries"),
		   action='store_true', dest='ABI_UPDATE', default=False)

    gr.add_option('--show-deps',
		   help=("Show dependency tree for the given target"),
		   dest='SHOWDEPS', default='')

    gr.add_option('--symbol-check',
                  help=("check symbols in object files against project rules"),
                  action='store_true', dest='SYMBOLCHECK', default=False)

    gr.add_option('--dup-symbol-check',
                  help=("check for duplicate symbols in object files and system libs (must be configured with --enable-developer)"),
                  action='store_true', dest='DUP_SYMBOLCHECK', default=False)

    gr.add_option('--why-needed',
                  help=("TARGET:DEPENDENCY check why TARGET needs DEPENDENCY"),
                  action='store', type='str', dest='WHYNEEDED', default=None)

    gr.add_option('--show-duplicates',
                  help=("Show objects which are included in multiple binaries or libraries"),
                  action='store_true', dest='SHOW_DUPLICATES', default=False)

    gr = opt.add_option_group('cross compilation options')

    gr.add_option('--cross-compile',
		   help=("configure for cross-compilation"),
		   action='store_true', dest='CROSS_COMPILE', default=False)
    gr.add_option('--cross-execute',
		   help=("command prefix to use for cross-execution in configure"),
		   action='store', dest='CROSS_EXECUTE', default='')
    gr.add_option('--cross-answers',
		   help=("answers to cross-compilation configuration (auto modified)"),
		   action='store', dest='CROSS_ANSWERS', default='')
    gr.add_option('--hostcc',
		   help=("set host compiler when cross compiling"),
		   action='store', dest='HOSTCC', default=False)

    # we use SUPPRESS_HELP for these, as they are ignored, and are there only
    # to allow existing RPM spec files to work
    opt.add_option('--build',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_BUILD', default='')
    opt.add_option('--host',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_HOST', default='')
    opt.add_option('--target',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_TARGET', default='')
    opt.add_option('--program-prefix',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_PROGRAM_PREFIX', default='')
    opt.add_option('--disable-dependency-tracking',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_DEPENDENCY_TRACKING', default=False)
    opt.add_option('--disable-silent-rules',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_SILENT_RULES', default=False)

    gr = opt.option_group('dist options')
    gr.add_option('--sign-release',
                   help='sign the release tarball created by waf dist',
                   action='store_true', dest='SIGN_RELEASE')
    gr.add_option('--tag',
                   help='tag release in git at the same time',
                   type='string', action='store', dest='TAG_RELEASE')

    opt.add_option('--disable-python',
                    help='do not generate python modules',
                    action='store_true', dest='disable_python', default=False)


@Utils.run_once
def configure(conf):
    conf.env.hlist = []
    conf.env.srcdir = conf.srcnode.abspath()

    conf.define('SRCDIR', conf.env['srcdir'])

    conf.SETUP_CONFIGURE_CACHE(Options.options.enable_configure_cache)

    # load our local waf extensions
    conf.load('gnu_dirs')
    conf.load('wafsamba')

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

import sys
import os

# find the buildtools directory
top = '.'
while not os.path.exists(top+'/buildtools') and len(top.split('/')) < 5:
    top = top + '/..'
sys.path.insert(0, top + '/buildtools/wafsamba')

out = 'bin'

import wafsamba
from wafsamba import samba_dist
from waflib import Options, Utils, Logs, Context

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools third_party/waf:third_party/waf')

def options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.PRIVATE_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@Utils.run_once
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.env.standalone_replace = conf.IN_LAUNCH_DIR()

    conf.DEFINE('BOOL_DEFINED', 1)
    conf.DEFINE('HAVE_LIBREPLACE', 1)
    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    conf.CHECK_HEADERS('linux/types.h crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h attr/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('port.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/ucontext.h sys/wait.h sys/stat.h')

    if not conf.CHECK_DECLS('malloc', headers='stdlib.h'):
        conf.CHECK_HEADERS('malloc.h')

    conf.CHECK_HEADERS('grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('errno.h')
    conf.CHECK_HEADERS('getopt.h iconv.h')
    conf.CHECK_HEADERS('memory.h nss.h sasl/sasl.h')

    conf.CHECK_FUNCS_IN('inotify_init', 'inotify', checklibc=True,
                        headers='sys/inotify.h')

    conf.CHECK_HEADERS('security/pam_appl.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('sys/unistd.h alloca.h float.h')

    conf.SET_TARGET_TYPE('tirpc', 'EMPTY')

    if conf.CHECK_CODE(
            '\n#ifndef _TIRPC_RPC_H\n#error "no tirpc headers in system path"\n#endif\n',
            'HAVE_RPC_RPC_HEADERS',
            headers=['rpc/rpc.h', 'rpc/nettype.h'],
            msg='Checking for tirpc rpc headers in default system path'):
        if conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            conf.undefine('HAVE_RPC_RPC_H')

    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libtirpc', args='--cflags --libs',
                       msg='Checking for libtirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
        if conf.CHECK_CFG(package='libntirpc', args='--cflags',
                       msg='Checking for libntirpc headers',
                       uselib_store='TIRPC'):
            conf.CHECK_HEADERS('rpc/rpc.h rpc/nettype.h', lib='tirpc', together=True)
            conf.SET_TARGET_TYPE('tirpc', 'SYSLIB')
    if not conf.CONFIG_SET('HAVE_RPC_RPC_H'):
            Logs.warn('No rpc/rpc.h header found, tirpc or libntirpc missing?')

    # This file is decprecated with glibc >= 2.30 so we need to check if it
    # includes a deprecation warning:
    # #warning "The <sys/sysctl.h> header is deprecated and will be removed."
    conf.CHECK_CODE('''
                    #include <sys/sysctl.h>
                    int main(void) { return 0; }
                    ''',
                    define='HAVE_SYS_SYSCTL_H',
                    cflags=['-Werror=cpp'],
                    addmain=False,
                    msg='Checking for header sys/sysctl.h')

    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h')

    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h')
    conf.CHECK_HEADERS('valgrind/memcheck.h valgrind/helgrind.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')
    conf.CHECK_HEADERS('sys/atomic.h stdatomic.h')
    conf.CHECK_HEADERS('libgen.h')

    if conf.CHECK_CFLAGS('-Wno-format-truncation'):
        conf.define('HAVE_WNO_FORMAT_TRUNCATION', '1')

    if conf.CHECK_CFLAGS('-Wno-unused-function'):
        conf.define('HAVE_WNO_UNUSED_FUNCTION', '1')

    if conf.CHECK_CFLAGS('-Wno-strict-overflow'):
        conf.define('HAVE_WNO_STRICT_OVERFLOW', '1')

    # Check for process set name support
    conf.CHECK_CODE('''
                    #include <sys/prctl.h>
                    int main(void) {
                        prctl(0);
                        return 0;
                    }
                    ''',
                    'HAVE_PRCTL',
                    addmain=False,
                    headers='sys/prctl.h',
                    msg='Checking for prctl syscall')

    conf.CHECK_CODE('''
                    #include <unistd.h>
                    #ifdef HAVE_FCNTL_H
                    #include <fcntl.h>
                    #endif
                    int main(void) { int fd = open("/dev/null", O_DIRECT); }
                    ''',
                    define='HAVE_OPEN_O_DIRECT',
                    addmain=False,
                    msg='Checking for O_DIRECT flag to open(2)')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')
    conf.CHECK_TYPE('bool', define='HAVE_BOOL')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('uint8_t', 'unsigned char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')
    conf.CHECK_TYPE('blksize_t', 'long', headers='sys/types.h sys/stat.h unistd.h')
    conf.CHECK_TYPE('blkcnt_t', 'long', headers='sys/types.h sys/stat.h unistd.h')

    conf.CHECK_SIZEOF('bool char int "long long" long short size_t ssize_t')
    conf.CHECK_SIZEOF('int8_t uint8_t int16_t uint16_t int32_t uint32_t int64_t uint64_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')
    conf.CHECK_SIZEOF('off_t dev_t ino_t time_t')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')
    conf.CHECK_FUNCS('sigsetmask siggetmask sigprocmask sigblock sigaction sigset')

    # Those functions are normally available in libc
    if not conf.CHECK_FUNCS('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h'):
        conf.CHECK_FUNCS_IN('''
                            inet_ntoa
                            inet_aton
                            inet_ntop
                            inet_pton
                            connect
                            gethostbyname
                            getaddrinfo
                            getnameinfo
                            freeaddrinfo
                            gai_strerror
                            socketpair''',
                            'socket nsl',
                            headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')
        conf.DEFINE('REPLACE_REQUIRES_LIBSOCKET_LIBNSL', 1)

    conf.CHECK_FUNCS('memset_s memset_explicit')

    conf.CHECK_CODE('''
                    #include <string.h>

                    int main(void)
                    {
                        char buf[] = "This is some content";
                        memset(buf, '\0', sizeof(buf)); __asm__ volatile("" : : "g"(&buf) : "memory");
                        return 0;
                    }
                    ''',
                    define='HAVE_GCC_VOLATILE_MEMORY_PROTECTION',
                    addmain=False,
                    msg='Checking for volatile memory protection',
                    local_include=False)

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
                           const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,

=== debian/changelog ===
tdb (1.4.5-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:34:47 +0000

tdb (1.4.5-2) unstable; urgency=medium

  * CI: Allow failures for te bhlc job
  * Add 0001-Add-support-for-GNU-kFreeBSD.patch (Closes: #990877)

 -- Mathieu Parent <sathieu@debian.org>  Tue, 14 Dec 2021 20:45:23 +0100

tdb (1.4.5-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Mathieu Parent ]
  * New upstream version 1.4.5
    - Update symbols
    - Update 30_tdb_logging_func.diff
  * Standards-Version: 4.6.0, no change
  * d/copyright: Remove duplicate globbing pattern
  * Update watch file format version to 4.

 -- Mathieu Parent <sathieu@debian.org>  Mon, 13 Dec 2021 21:52:11 +0100

=== debian/control ===
Source: tdb
Section: devel
Priority: optional
Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Jelmer Vernooĳ <jelmer@debian.org>, Mathieu Parent <sathieu@debian.org>
Build-Depends: debhelper-compat (= 12),
               dh-python,
               docbook-xml,
               docbook-xsl,
               python3-dev,
               xsltproc
Rules-Requires-Root: no
Homepage: https://tdb.samba.org/
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/samba-team/tdb
Vcs-Git: https://salsa.debian.org/samba-team/tdb.git

Package: libtdb1
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Trivial Database - shared library
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the shared library file.

Package: tdb-tools
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Trivial Database - bundled binaries
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains bundled test and utility binaries

Package: libtdb-dev
Multi-Arch: same
Provides: tdb-dev
Section: libdevel
Architecture: any
Depends: libc6-dev, libtdb1 (= ${binary:Version}), ${misc:Depends}
Description: Trivial Database - development files
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the development files.

Package: python3-tdb
Section: python
Architecture: any
Depends: libtdb1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python3 bindings for TDB
 This is a simple database API. It is modelled after the structure
 of GDBM. TDB features, unlike GDBM, multiple writers support with
 appropriate locking and transactions.
 .
 This package contains the Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -g -Wall

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

DESTDIR=$(CURDIR)/debian/tmp

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	CPPFLAGS="$(CPPFLAGS)" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
		./configure --prefix=/usr --disable-rpath-install \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-v

get-packaged-orig-source:
	./debian/build-orig.sh

override_dh_auto_build:
	$(MAKE) all V=2

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) check
endif

override_dh_auto_clean:
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf build
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8854
	rm -f .lock-wscript
	# Waf should be doing this; see
	# https://bugzilla.samba.org/show_bug.cgi?id=8855
	rm -rf buildtools/wafsamba/__pycache__ \
	       third_party/waf/waflib/__pycache__/ \
	       third_party/waf/waflib/extras/__pycache__/ \
	       third_party/waf/waflib/Tools/__pycache__/

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(DESTDIR)
	# Waf should be doing this..
	ar cr libtdb.a bin/default/common/*.o
	mv libtdb.a $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
	mv $(DESTDIR)/usr/bin/tdbbackup \
		$(DESTDIR)/usr/bin/tdbbackup.tdbtools
	mv $(DESTDIR)//usr/share/man/man8/tdbbackup.8 \
		$(DESTDIR)/usr/share/man/man8/tdbbackup.tdbtools.8

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -Npython3-tdb -- -c4

## tdb 1.4.6

=== debian/changelog ===
tdb (1.4.6-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 04 May 2022 19:06:55 +0300

tdb (1.4.6-2) unstable; urgency=medium

  * d/rules include buildflags.mk instead of open-coding CFLAGS etc definitions
  * d/rules: remove _PUBLIC_ markers from public header file
    fixing samba-4.16 ftbfs
  * d/rules: clean up bin/ not build/

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 26 Mar 2022 19:23:34 +0300

tdb (1.4.6-1) unstable; urgency=medium

  * New upstream version 1.4.6
    - update symbols
  * Switch to debhelper-compat = 13
  * Add myself to Uploaders

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 23 Mar 2022 12:31:55 +0300

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,10 @@
 Section: devel
 Priority: optional
 Maintainer: Debian Samba Maintainers <pkg-samba-maint@lists.alioth.debian.org>
-Uploaders: Jelmer Vernooĳ <jelmer@debian.org>, Mathieu Parent <sathieu@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Uploaders: Jelmer Vernooĳ <jelmer@debian.org>,
+           Mathieu Parent <sathieu@debian.org>,
+           Michael Tokarev <mjt@tls.msk.ru>
+Build-Depends: debhelper-compat (= 13),
                dh-python,
                docbook-xml,
                docbook-xsl,

=== debian/rules ===
--- 
+++ 
@@ -3,14 +3,10 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = -g -Wall
 
-CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
-CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
-CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
-LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
+include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildflags.mk
 
 DESTDIR=$(CURDIR)/debian/tmp
-
-include /usr/share/dpkg/architecture.mk
 
 %:
 	dh $@ --with python3
@@ -34,7 +30,7 @@
 
 override_dh_auto_clean:
 	[ ! -f Makefile ] || $(MAKE) distclean
-	rm -rf build
+	rm -rf bin
 	# Waf should be doing this; see
 	# https://bugzilla.samba.org/show_bug.cgi?id=8854
 	rm -f .lock-wscript
@@ -54,6 +50,9 @@
 		$(DESTDIR)/usr/bin/tdbbackup.tdbtools
 	mv $(DESTDIR)//usr/share/man/man8/tdbbackup.8 \
 		$(DESTDIR)/usr/share/man/man8/tdbbackup.tdbtools.8
+	#HACK alert: fix up wrong markers in the common include file
+	sed -i 's/^_PUBLIC_ //' ${DESTDIR}/usr/include/tdb.h
+	touch --reference=include/tdb.h ${DESTDIR}/usr/include/tdb.h
 
 override_dh_missing:
 	dh_missing --fail-missing

## tdb 1.4.7

=== debian/changelog ===
tdb (1.4.7-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports (no changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 03 Nov 2022 08:11:03 +0300

tdb (1.4.7-2) unstable; urgency=medium

  * d/rules: inline parallel check from dpkg/buildopts.mk
  * d/rules: use ${} for variables consistently
  * d/rules: use $(filter) instead of $(findstring) to look for nocheck
    in ${DEB_BUILD_OPTIONS}

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 30 Oct 2022 11:51:37 +0300

tdb (1.4.7-1) unstable; urgency=medium

  * new upstream release 1.4.7
  * remove 0001-Add-support-for-GNU-kFreeBSD.patch (applied upstream)
  * d/libtdb1.symbols: add new version
  * d/control: bump std-version to 4.6.1 (no changes)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 09 Sep 2022 13:34:49 +0300

tdb (1.4.6-3) unstable; urgency=medium

  * many tweaks for d/rules:
   - switch from --with python to dh-sequence-python3
     and stop overriding --fail-missing with dh=13
   - replace slow architecture.mk with fast inline version
   - reorder targets for readability
   - reorder configure arguments for readability
   - rework clean target
   - move libtdb.a build to build target and build it in bin/
   - restrict targets for which we run dh
   - stop overriding dh_makeshlibdeps,
     set DPKG_GENSYMBOLS_CHECK_LEVEL instead
   - make configure & build depend on config-stamp
     to stop configure rerun on each build
   - set SHELL to /bin/sh -e
  * remove _PUBLIC_ define from the public header entirely,
    not only the usage of this define, to stop polluting
    the namespace

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 04 May 2022 20:11:55 +0300

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,14 @@
            Mathieu Parent <sathieu@debian.org>,
            Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                docbook-xml,
                docbook-xsl,
                python3-dev,
                xsltproc
 Rules-Requires-Root: no
 Homepage: https://tdb.samba.org/
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/samba-team/tdb
 Vcs-Git: https://salsa.debian.org/samba-team/tdb.git

## tdb 1.4.8

=== debian/changelog ===
tdb (1.4.8-2) unstable; urgency=medium

  * d/rules: build for all installed py3versions
    instead of default/supported (not enabled still)
  * d/control: Standards-Version: 4.6.2 (no changes)
  * d/control: remove unused ${python3:Provides}
  * d/control: put all doc-generating build-deps into one line
  * little prep for cross-compilation
  * d/control: work around autodep8 #904999 again

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 04 Feb 2023 17:12:31 +0300

tdb (1.4.8-1) unstable; urgency=medium

  * new upstream release (1.4.8, from samba 4.18):
    - Support python 3.12
  * d/libtdb1.symbols: add new version

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 21 Jan 2023 10:33:25 +0300

tdb (1.4.7-3) unstable; urgency=medium

  * Allow building for multiple python3 versions (disabled for now)
  * d/rules: support "terse" build option for non-verbose build
  * d/source/lintian-overrides: add 2 overrides
  * d/salsa-ci.yml:
    - instead of allowing blhc to (always) fail, disable it
    - disable crossbuild-arm64 test (samba does not cross-build)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 20 Jan 2023 18:48:56 +0300

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,14 @@
            Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
-               docbook-xml,
-               docbook-xsl,
-               python3-dev,
-               xsltproc
+               docbook-xml, docbook-xsl, xsltproc,
+# use {python3,libpython3}-ALL-dev to build for all python3 versions (+#904999):
+               python3-dev:any | python3-dev, libpython3-dev,
+# host python is needed for selftests
+               python3 <!nocheck>,
 Rules-Requires-Root: no
 Homepage: https://tdb.samba.org/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/samba-team/tdb
 Vcs-Git: https://salsa.debian.org/samba-team/tdb.git
 
@@ -61,7 +62,6 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Provides: ${python3:Provides}
 Description: Python3 bindings for TDB
  This is a simple database API. It is modelled after the structure
  of GDBM. TDB features, unlike GDBM, multiple writers support with

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -g -Wall
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# Fast version of dpkg/architecture.mk defining all vars in one go
ifeq (${DEB_HOST_MULTIARCH},)
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk
V := $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)
WAF := PYTHONHASHSEED=1 ./buildtools/bin/waf \
	$(patsubst parallel=%,-j%,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

ifeq (linux,${DEB_HOST_ARCH_OS})
# for cross-build or build with foreign python binary (it is _gnu0_i386-gnu on hurd)
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__${DEB_HOST_ARCH_OS}_${DEB_HOST_MULTIARCH}
endif

# All supported installed python versions we build for
export PY3VERSIONS := $(or ${PY3VERSIONS}, $(shell py3versions -i))

DESTDIR := ${CURDIR}/debian/tmp

build-arch build-indep build \
install-arch install-indep install \
binary-arch binary-indep binary \
: %:
	dh $@

# Build in bld/pyNN/ subdirs (named after python version),
# Since wafsamba can't build things in a named subdir,
# we have to copy (link) whole source dir into each build subdir.

.NOTPARALLEL: # don't run commands at this level in parallel

py-targets = $(patsubst %, bld/%/$(strip $1), ${PY3VERSIONS})

override_dh_auto_configure: $(call py-targets, stamp-config)
$(call py-targets, stamp-config): %/stamp-config:
	@echo "=== running configure in $* ==="
	mkdir -p $*
	cp -al $$(ls -1 | egrep -v '^(bld|debian)$$') $*
	cd $*; \
	    CC="${CC}" CPP="${CPP}" LD="${LD}" PKGCONFIG="${PKG_CONFIG}" \
	    CPPFLAGS="${CPPFLAGS}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" \
	    PYTHON=$(notdir $*) PYTHON_CONFIG=${DEB_HOST_MULTIARCH}-$(notdir $*)-config \
	    ${WAF} -j1 -C configure \
		--prefix=/usr \
		--libdir=/usr/lib/${DEB_HOST_MULTIARCH} \
		--disable-rpath --disable-rpath-install \
		--bundled-libraries=NONE \

	touch $@

override_dh_auto_build: $(call py-targets, stamp-build)
$(call py-targets, stamp-build): %/stamp-build: %/stamp-config
	@echo "=== running build in $* ==="
	cd $*; ${WAF} $(if $V,-v) build
	# Waf should be doing this..
	ar cr $*/bin/libtdb.a $*/bin/default/common/*.o

# the testsuite does not test python bindings so there's no reason to test all pyversions
override_dh_auto_test: \
  $(if $(filter nocheck,${DEB_BUILD_OPTIONS}), , $(firstword $(call py-targets, test)))
$(call py-targets, test): %/test: %/stamp-build
	@echo "=== running test in $* ==="
	cd $*; ${WAF} test

$(call py-targets, install): %/install: %/stamp-build
	@echo "=== running install in $* ==="
	cd $*; ${WAF} install --destdir=${DESTDIR}
	cp $*/bin/libtdb.a ${DESTDIR}/usr/lib/${DEB_HOST_MULTIARCH}/
override_dh_auto_install: $(call py-targets, install)
	mv ${DESTDIR}/usr/bin/tdbbackup \
		${DESTDIR}/usr/bin/tdbbackup.tdbtools
	mv ${DESTDIR}/usr/share/man/man8/tdbbackup.8 \
		${DESTDIR}/usr/share/man/man8/tdbbackup.tdbtools.8
	#HACK alert: fix up wrong markers in the common include file
	sed -i 's/^_PUBLIC_ //' ${DESTDIR}/usr/include/tdb.h
	# ..and remove the #define itself
	patch --batch ${DESTDIR}/usr/include/tdb.h debian/header-remove-_PUBLIC_-define.patch

clean:
	dh_clean bld/

get-packaged-orig-source:
	./debian/build-orig.sh

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/tar\.gz/tar.asc/,decompress https://download.samba.org/pub/tdb/ tdb-(.+).tar.gz
